var oah_loaded = 0; // eslint-disable-line no-var
var oah_processedSinglePageApplication = false; // eslint-disable-line no-var
var spaUrl = location.href; // eslint-disable-line no-var
var configuration; // eslint-disable-line no-var

var preprintServers = ['arxiv.org', 'biorxiv.org', 'osf.io', 'engrxiv.org', 'psyarxiv.com', 'paleorxiv.org', 'eartharxiv.org', 'edarxiv.org', 'arabixiv.org', 'indiarxiv.org', 'biohackrxiv.org', 'ecoevorxiv.org', 'ecsarxiv.org', 'frenxiv.org', 'mediarxiv.org', 'thesiscommons.org']; // eslint-disable-line no-var

if (typeof (EXT_NAME_CONTENT_SCRIPT_LOADED) === 'undefined') {
  var EXT_NAME_CONTENT_SCRIPT_LOADED = true;

  const ExtName = {};

  //---------------------------------------------------------------------------------
  ExtName.initialize = function () {
    // On document ready
    docReady(() => {
      // Load CSS
      const path = chrome.extension.getURL('css/content.css');
      const link = document.createElement('link');
      link.setAttribute('rel', 'stylesheet');
      link.setAttribute('type', 'text/css');
      link.setAttribute('href', path);
      document.getElementsByTagName('head')[0].appendChild(link);
      if (!inIframe() && oah_loaded == 0) {
        oah_loaded++;
        addMessageListener();
        getConfigAndStart();
      }
    }); // End of document.ready
    // End of initialize
  };

  //-------------------------------------------------------------------------------------
  // Start the extension content script
  ExtName.initialize();
}

function docReady(fn) {
  // see if DOM is already available
  if (document.readyState === 'complete' || document.readyState === 'interactive') {
    // call on next available tick
    setTimeout(fn, 1);
  } else {
    document.addEventListener('DOMContentLoaded', fn);
  }
}


if (window.location.hostname == 'gettheresearch.org' || onSupportedDomain('psycnet.apa.org')) {
  document.addEventListener('click', () => {
    requestAnimationFrame(() => {
      if (spaUrl !== location.href) {
        oah_processedSinglePageApplication = false;
        removeMyself();
        findDoi3();
      } else if (onSupportedDomain('psycnet.apa.org')) {
        // moving from search results to first result never triggered the URL change
        // doConsoleLog('OAHELPER: I am on psycnet');
        setTimeout(() => {
          doPsycNet();
        }, 1500);
      }
      spaUrl = location.href;
    });
  }, true);
}

// support gettheresearch SPA
function removeMyself() {
  const elementRecom = document.getElementById('oahelper_corerecom_outer');
  if (elementRecom != null) {
    elementRecom.parentNode.removeChild(elementRecom);
  }
  const element = document.getElementById('oahelper_doifound_outer');
  if (element != null) {
    element.parentNode.removeChild(element);
  }
}

function addMessageListener() {
  chrome.runtime.onMessage.addListener((request, sender, sendResponse) => {
    // console.log(request);
    switch (request.mode) {
      case 'getBadge':
        sendResponse({ mode: 'getBadgeResponse', badge: getBadge() });
        return true;
	    case 'popup':
        sendResponse({ mode: 'popupAnswer', data: getPopupAnswer(), configuration });
        return true;
      case 'hidebadges':
        hideBadgeRequest();
        sendResponse({ mode: 'badgehidden' });
        return true;
      default:
        return true;
    }
  });
}

function getConfigAndStart() {
  chrome.runtime.sendMessage({ mode: 'getoptions' }, (response) => {
    if (response.options != undefined && !response.options != null) {
      configuration = response.options;
      findDoi();
    }
  });
}

function getBadge() {
  let badge = '';
  const oahelper_doicheckmark = document.getElementById('oahelper_doicheckmark');
  if (oahelper_doicheckmark != undefined) {
    if (oahelper_doicheckmark.dataset.badge != undefined) {
      badge = oahelper_doicheckmark.dataset.badge;
    }
  }
  if (badge == '') {
    const opencitation_check = document.getElementById('oahelper_opencitations_logo');
    if (opencitation_check != undefined) {
      if (opencitation_check.dataset.badge != undefined) {
        badge = opencitation_check.dataset.badge;
      }
    }
  }
  return badge;
}

function getPopupAnswer() {
  let response = {
    oaurl: '',
    oastatus: '',
    citationcount: 0,
    citationurl: '',
    currenturl: window.location.href,
    isIll: '',
    doi: '',
    shouldProxy: true
  };

  const oaurlElement = document.getElementById('oahelper_doicheckmark');
  const oaStatusElement = document.getElementById('oahelper_oahelpmsg');
  const citationElement = document.getElementById('oahelper_opencitations_msg');
  const citationUrlElement = document.getElementById('oahelper_opencitations_logo');
  
  if(oaurlElement != undefined){
    if(oaurlElement.dataset.badge != undefined) {
      response.isIll = oaurlElement.dataset.badge;
    }
    response.doi = oaurlElement.dataset.doi;
  }

  if (oaurlElement != undefined && oaurlElement.dataset.oaurl) {
    response.oaurl = oaurlElement.dataset.oaurl;
  }

  if (oaStatusElement != undefined) {
    response.oastatus = oaStatusElement.innerText;
  }

  if (citationElement != undefined) {
	  response.citationcount = parseInt(citationUrlElement.dataset.citcount);
  }

  if (citationUrlElement != undefined) {
	  response.citationurl = citationUrlElement.dataset.oaurl;
  }

  if (configuration.domainurl != undefined && configuration.domainurl != '' && configuration.supportedDomains != undefined && configuration.supportedDomains.length > 0) {
    response.shouldProxy = shouldProxy(window.location.href);
  }

  return response;
}

function hideBadgeRequest() {
  if (document.getElementById('oahelper_doifound_outer') != null) {
    document.getElementById('oahelper_doifound_outer').style.display = 'none';
  }
  if (document.getElementById('oahelper_opencitations_outer') != null) {
    document.getElementById('oahelper_opencitations_outer').style.display = 'none';
  }
  if (document.getElementById('oahelper_corerecom_outer') != null) {
    document.getElementById('oahelper_corerecom_outer').style.display = 'none';
  }
}

function findDoi() {
  // doConsoleLog("Open Acces Helper: DOI0");
  // we are going to look in meta-tags for the DOI
  const option = ['citation_doi', 'doi', 'dc.doi', 'dc.identifier', 'dc.identifier.doi', 'bepress_citation_doi', 'rft_id', 'dcsext.wt_doi', 'DC.identifier'];
  const doi = [];
  for (i = 0; i < option.length; i++) {
    const potentialDoiArray = getMeta(option[i]);
    for (j = 0; j < potentialDoiArray.length; j++) {
      const testDoi = potentialDoiArray[j];
      if (testDoi != '' && isDOI(cleanDOI(testDoi))) {
        doi.push(cleanDOI(testDoi));
      }
    }
  }
  executeFoundDoi(doi);
}

function executeFoundDoi(doi) {
  if (doi[0] != undefined && doi[0] != '') {
    cleanedDOI = cleanDOI(doi[0]);
    doConsoleLog(chrome.i18n.getMessage('content_console_001', [0, cleanedDOI]));
    const url = encodeURI(location.href);
    doUnpayWall(cleanedDOI);
  } else {
    // didn't find a DOI yet, so let's look in another place
    findDoi1();
  }
}

function findDoi1() {
  // doConsoleLog("Open Acces Helper: DOI1");
  // in this case, we are looking for both meta-tag and its scheme
  const potentialDoiArray = getMetaScheme('dc.Identifier', 'doi');
  const doi = [];
  for (i = 0; i < potentialDoiArray.length; i++) {
    const testDoi = potentialDoiArray[i];
    if (testDoi != '' && isDOI(cleanDOI(testDoi))) {
      doi.push(cleanDOI(testDoi));
    }
  }

  if (doi[0] != undefined && doi[0] != '') {
    doConsoleLog(chrome.i18n.getMessage('content_console_001', [1, doi[0]]));
    const url = encodeURI(location.href);
    doUnpayWall(doi[0]);
  } else {
    // didn't find a DOI yet, let's look in yet another place
    findDoi2();
  }
}

function findDoi2() {
  // doConsoleLog("Open Acces Helper: DOI2");
  // this is a place for more complex fallbacks, where we can provide additional "CSS-Selectors" to find
  // a DOI. Right now it really only handles a single case, but hopefully there will be aditional cases
  // in future
  const selectors = ['a[ref=\"aid_type=doi\"]', 'a.citation__doi__link'];
  let doi = '';
  for (i = 0; i < selectors.length; i++) {
    doi = getFromSelector(selectors[i]);
    if (doi != '') {
      break;
    }
  }
  if (doi != '') {
    doConsoleLog(chrome.i18n.getMessage('content_console_001', [2, doi]));
    const url = encodeURI(location.href);
    doUnpayWall(doi);
  } else {
    // we are ready to give up here, but not quite
    findDoi3();
  }
}

function findDoi3() {
  // doConsoleLog("Open Acces Helper: DOI3");
  // this handled Research Gate or others that use meta property
  const selectors = ['citation_doi', 'doi', 'dc.doi', 'dc.identifier', 'dc.identifier.doi', 'bepress_citation_doi', 'rft_id', 'dcsext.wt_doi', 'DC.identifier'];
  let doi = '';
  for (i = 0; i < selectors.length; i++) {
    doi = getMetaProperty(selectors[i]);
    if (doi != 0) {
      break;
    }
  }
  if (doi != 0) {
    doConsoleLog(chrome.i18n.getMessage('content_console_001', [3, doi]));
    const url = encodeURI(location.href);
    doUnpayWall(doi);
  } else {
    // we are ready to give up here, but not quite
    findDoi4();
  }
}

function findDoi4() {
  // doConsoleLog("Open Acces Helper: DOI3");
  // if we cannot work through specific selectors, a more general scraping approach might be neeeded
  // to avoid doing this on every page, we specify the pages we support

  const host = window.location.hostname;
  if(onSupportedDomain('ieeexplore.ieee.org')){
    // IEEE
    // this is a Single Page Application and the delay helps catch the DOI
    setTimeout(() => {
      const regex = new RegExp('"doi":"([^"]+)"');
      const doi = runRegexOnDoc(regex);
      if (doi != false) {
        scrapedDoi(doi);
      } else {
        alternativeOA('n', 'n', '-');
      }
    }, 1500);
  } else if(onSupportedDomain('nber.org')){
    // National Bureau of Economic Research
    var regex = new RegExp('Document Object Identifier \\(DOI\\): (10.*?)<\\/p>');
    var doi = runRegexOnDoc(regex);

    scrapedDoi(doi);
  } else if(onSupportedDomain('base-search.et')){
    // BASE SEARCH - for detail view, really quite superflous, but I like base
    if (document.querySelectorAll('a.link-orange[href^="https://doi.org/"]').length > 0) {
      var doi = document.querySelectorAll('a.link-orange[href^="https://doi.org/"]')[0].href.replace('https://doi.org/', '').replace('http://doi.org/', '');
      scrapedDoi(doi);
    } else {
      alternativeOA('n', 'n', '-');
    }
  } else if (onSupportedDomain('gettheresearch.org')) {
    doConsoleLog(chrome.i18n.getMessage('content_console_002', 'gettheresearch.org'));
    // GetTheResearch.org- for detail view, really quite superflous, but I like base
    if (window.location.search.indexOf('zoom=') > -1) {
      var potentialDoi = getQueryVariable('zoom');
      scrapedDoi(potentialDoi);
    }
  } else if (onSupportedDomain('psycnet.apa.org')) {
    doConsoleLog(chrome.i18n.getMessage('content_console_002', 'psycnet.apa.org'));

    if (document.querySelectorAll('.citation-text>a').length > 0) {
      var doiElements = document.querySelectorAll('.citation-text>a');
      var potentialDoi = doiElements[0];
      potentialDoi = potentialDoi.replace('https://doi.org/', '');
      scrapedDoi(potentialDoi);
    } else {
      doPsycNet();
    }
  } else if (onSupportedDomain('proquest.com')) {
    doConsoleLog(chrome.i18n.getMessage('content_console_002', 'proquest.com'));

    if (document.querySelectorAll('.abstract_Text').length > 0) {
      var doiElements = document.querySelectorAll('.abstract_Text');
      var potentialDoi = doiElements[0];
      var regex = new RegExp('DOI:(10\..*)');
      var doi = runRegexOnText(potentialDoi.textContent, regex);
      // doConsoleLog(doi);
      scrapedDoi(doi);
    }
  } else if (onSupportedDomain('ebscohost.com') && document.location.href.indexOf('/detail') > -1) {
    doConsoleLog(chrome.i18n.getMessage('content_console_002', 'ebscohost.com'));

    const fullTextIndicators = ['pdf-ft', 'html-ft', 'html-ftwg'];
    let isFullText = false;
    fullTextIndicators.forEach((item) => {
      const element = document.getElementsByClassName(item);
      if (element.length > 0) {
        isFullText = true;
      }
    });

    if (document.getElementsByTagName('dd').length > 0) {
      var doiElements = document.getElementsByTagName('dd');
      [...doiElements].forEach((element) => {
        if (element.textContent.indexOf('10.') == 0 && isDOI(element.textContent)) {
          if (isFullText) {
            doConsoleLog(chrome.i18n.getMessage('content_console_003'));
            if (isDOI(element.textContent)) {
              doCitationCount(element.textContent);
            }
          } else {
            scrapedDoi(element.textContent);
          }
        }
      });
    }
  } else if (onSupportedDomain('dl.acm.org') && document.location.href.indexOf('/doi/') > -1) {
    doConsoleLog(chrome.i18n.getMessage('content_console_002', 'dl.acm.org'));
    const urlParts = document.location.href.split('/doi/');
    if (isDOI(urlParts[1])) {
      scrapedDoi(urlParts[1]);
    }
  } else {
    // doConsoleLog("Open Acces Helper: Failed on DOI3");
    // we are ready to give up here and send a notfound message, so that we can deactivate the icon
    // safari.extension.dispatchMessage('notfound', { doi: '' });
    // however we'll continue look at the alternativeOA Webscraping methods
    alternativeOA('n', 'n', '-');
  }
}

function onSupportedDomain(domain){
  const host = window.location.hostname;
  if(host.indexOf(domain) > -1){
    return true;
  }
  const proxiedDomain = domain.replaceAll('.', '-')+'.';
  if(host.indexOf(proxiedDomain) > -1){
    return true;
  }
  return false;
}


function getMeta(metaName) {
  // get meta tags and loop through them. Looking for the name attribute and see if it is the metaName
  // we were looking for
  const metas = document.getElementsByTagName('meta');
  const response = [];

  for (let i = 0; i < metas.length; i++) {
    if (metas[i].getAttribute('name') === metaName) {
      response.push(metas[i].getAttribute('content'));
    }
  }
  return response;
}

function getMetaForAbstract(metaName) {
  // get meta tags and loop through them. Looking for the name attribute and see if it is the metaName
  // we were looking for
  const metas = document.getElementsByTagName('meta');

  for (let i = 0; i < metas.length; i++) {
    if (metas[i].getAttribute('name') === metaName) {
      return metas[i].getAttribute('content');
    }
  }

  return '0';
}

function getMetaScheme(metaName, scheme) {
  // pretty much the same as the other function, but it also double-checks the scheme
  const metas = document.getElementsByTagName('meta');
  const response = [];
  for (let i = 0; i < metas.length; i++) {
    if (metas[i].getAttribute('name') === metaName && metas[i].getAttribute('scheme') === scheme) {
      response.push(metas[i].getAttribute('content'));
    }
  }

  return response;
}

function getMetaProperty(metaName) {
  const metas = document.getElementsByTagName('meta');

  for (let i = 0; i < metas.length; i++) {
    if (metas[i].getAttribute('property') === metaName) {
      return metas[i].getAttribute('content');
    }
  }

  return '0';
}

function getFromSelector(selector) {
  // allow for more complex CSS selectors, these are likely more unreliable
  const elements = document.querySelectorAll(selector);

  for (let i = 0; i < elements.length; i++) {
    // make sure we test what we find to be a proper DOI
    if (isDOI(cleanDOI(elements[i].innerHTML))) {
      return cleanDOI(elements[i].innerHTML);
    }
  }

  return '';
}

function getQueryVariable(variable) {
  const query = window.location.search.substring(1);
  const vars = query.split('&');
  for (let i = 0; i < vars.length; i++) {
    const pair = vars[i].split('=');
    if (decodeURIComponent(pair[0]) == variable) {
      return decodeURIComponent(pair[1]);
    }
  }
}

function cleanDOI(doi) {
  // clean for a few common known prefixes (well exactly one right now, but easy to expand
  const clean = ['info:doi/', 'https://doi.org/'];

  for (let i = 0; i < clean.length; i++) {
    doi = doi.replace(clean[i], '');
  }

  return doi;
}

function isDOI(doi) {
  // these regular expressions were recommended by CrossRef in a blog post
  // https://www.crossref.org/blog/dois-and-matching-regular-expressions/
  const regex1 = /^10.\d{4,9}\/[-._;()\/:A-Z0-9]+$/i;
  const regex2 = /^10.1002\/[^\s]+$/i;
  const regex3 = /^10.\d{4}\/\d+-\d+X?(\d+)\d+<[\d\w]+:[\d\w]*>\d+.\d+.\w+;\d$/i;
  const regex4 = /^10.1021\/\w\w\d+$/i;
  const regex5 = /^10.1207\/[\w\d]+\&\d+_\d+$/i;

  if (regex1.test(doi)) {
    return true;
  }
  if (regex2.test(doi)) {
    return true;
  }
  if (regex3.test(doi)) {
    return true;
  }
  if (regex4.test(doi)) {
    return true;
  }
  if (regex5.test(doi)) {
    return true;
  }

  return false;
}


function makeOaVersion(version) {
  const translation = chrome.i18n.getMessage(`content_version_${version}`);
  if (translation.length == 0) {
    return version;
  }
  return translation;
}


function oafound(message) {
  // here we inject the icon into the page
  // room for improvement, most Chrome extensions would inject an iFrame
  const src = chrome.runtime.getURL('images/oahelper_white.svg'); // padlock
  const oaVersionString = makeOaVersion(message.version);

  let oaVersion = '';
  if (oaVersionString != '') {
    oaVersion = ` - OA Version: ${oaVersionString}`;
  } else {
    oaVersion = 'CORE Discovery';
  }


  const div = document.createElement('div');
  div.innerHTML = `<div class="oahelper_doifound" id="oahelper_open1" data-url="${message.url}" title="${message.title}${oaVersion}"><img id="oahelper_doicheckmark" src="${src}" align="left" title="${message.title}${oaVersion}" data-oaurl="${message.url}" data-badge="!" data-doi="${message.doi}"/><span id="oahelper_oahelpmsg">${oaVersionString}</span></div><span id="oahelper_LiveRegion" role="alert" aria-live="assertive" aria-atomic="true"></span>`; // data-oaurl is a gift to ourselves
  div.id = 'oahelper_doifound_outer';
  div.className = 'oahelper_doifound_outer';
  if (configuration.nobadge) {
    div.className = 'oah_hidden';
  }

  if (document.body.parentNode.parentNode != '#document') {
    document.body.appendChild(div);

    doConsoleLog(chrome.i18n.getMessage('content_console_004', [message.source, message.url, oaVersion]));
    doOaHelperLiveRegion(message.title);
    const element = document.getElementById('oahelper_open1');
    element.addEventListener("click", oahelper_open1, false);
  }
}

function oahelper_open1() {
  const element = document.getElementById('oahelper_open1');
  const url = element.dataset.url;
  chrome.runtime.sendMessage({ mode: 'openTab', url }, (response) => {
    // console.log(response);
  });
}

function requestDocument(oab, doistring) {
  if(configuration.core1 != undefined && configuration.core1){
    const infoString = chrome.i18n.getMessage('content_corerecom_004');
    coreRecommenderStart(doistring, infoString, chrome.i18n.getMessage('content_close_label'));
  }
  // find out whether we are supposed to do CORE Recommender at All
  // safari.extension.dispatchMessage('doCoreRecom', { doistring });
  let isPreprint = false;
  preprintServers.forEach((server) => {
    if (document.location.href.indexOf(server) > -1) {
      isPreprint = true;
    }
  });
  // here we inject the icon into the page

  if (isPreprint) {
    return;
  }

  if (oab == 'n' && !configuration.ill) {
    return;
  }

  if (!configuration.oab && !configuration.ill) {
    return;
  }

  if (oab == 'e' && !configuration.ill) {
    doConsoleLog(chrome.i18n.getMessage('content_console_005')); // error obtaining data
    return;
  }

  if (oab == 'o' && !configuration.ill) {
    doConsoleLog(chrome.i18n.getMessage('content_console_006')); // pubyear > 5 years ago
    return;
  }

  if(doistring == '' || doistring == '-'){
    return;
  }

  const src = chrome.runtime.getURL('images/ask.svg'); // padlock
  let url = encodeURIComponent(location.href);
  let oabUrl = 'https://openaccessbutton.org/request?url=';
  let message = chrome.i18n.getMessage('content_oab_001');
  let usermsg = 'Open Access Button';
  let databadge = 'oab';
  if(configuration.ill){
    oabUrl = configuration.illurl+doistring;
    message = chrome.i18n.getMessage('content_ill_001');
    url = '';
    usermsg = chrome.i18n.getMessage('content_ill_002');
    databadge = 'ill';
  }
  const div = document.createElement('div');
  div.innerHTML = `<div class="oahelper_doifound" onclick="window.open('${oabUrl}${url}')" title="${message}"><img id="oahelper_doicheckmark" src="${src}" align="left"  title="${message}" data-oaurl="${oabUrl}${url}" data-badge="${databadge}" data-doi="${doistring}"/><span id="oahelper_oahelpmsg">${usermsg}</span></div><span id="oahelper_LiveRegion" role="alert" aria-live="assertive" aria-atomic="true"></span>`; // data-oaurl is a gift to ourselves
  div.id = 'oahelper_doifound_outer';
  div.className = 'oahelper_doifound_outer oahelper_doiblue';
  if (configuration.nobadge) {
    div.className = 'oah_hidden';
  }

  if (document.body.parentNode.parentNode != '#document') {
    document.body.appendChild(div);
  }
  doConsoleLog(chrome.i18n.getMessage('content_console_007'));
  const currentUrl = window.location.href;

  doOaHelperLiveRegion(message.title);
  chrome.runtime.sendMessage({ mode: 'setBlueIcon' }, (response) => {
    // console.log(response);
  });
}


// if on Open Access document, this will turn the injected badge / button green

function onOa(title) {
  const div = document.getElementById('oahelper_doifound_outer');
  div.classList.add('oahelper_doigreen');
  const div1 = document.getElementById('oahelper_doicheckmark');
  div1.dataset.badge = '✔';

  doOaHelperLiveRegion(title);
}


// simple helper to see if we are in an iframe, there are a lot of those on publisher sites
function inIframe() {
  try {
    return window.self !== window.top;
  } catch (e) {
    return true;
  }
}


// if oadoi gives back an empty result or not oa result,
// we will run this to see if we might OA on the page
// uses some site specific logic

function alternativeOA(message, oab, doistring) {
  chrome.runtime.sendMessage({ mode: 'getoptions' }, (response) => {
    if (response.options != undefined && !response.options != null) {
      configuration = response.options;
    }
  });

  const host = window.location.hostname;
  const path = window.location.pathname;
  const generator = getMeta('Generator');

  if (host.indexOf('ingentaconnect') > -1) {
    doIngentaConnect(oab, doistring, host);
  } else if (host.indexOf('base-search.net') > -1 && window.location.href.indexOf('/Record/') > -1) {
    doBaseSearch(oab, doistring, host);
  } else if (host.indexOf('ieeexplore.ieee.org') > -1) {
    doIEEExplore(oab, doistring, host);
  } else if (host.indexOf('journals.sagepub.com') > -1 && path.indexOf('doi') > -1) {
    doSagePub(oab, doistring, host);
  } else if (host.indexOf('academic.oup.com') > -1) {
    doOup(oab, doistring, host);
  } else if (host.indexOf('bmj.com') > -1) {
    doBmj(oab, doistring, host);
  } else if (host.indexOf('cambridge.org') > -1) {
    doCambridge(oab, doistring, host);
  } else if (host.indexOf('onlinelibrary.wiley.com') > -1 && path.indexOf('doi') > -1) {
    doWiley(oab, doistring, host);
  } else if (host.indexOf('link.springer.com') > -1 && path.indexOf('article') > -1) {
    doSpringerLink(oab, doistring, host);
  } else if (generator.length > 0 && generator[0].indexOf('DSpace') > -1) {
    doConsoleLog(chrome.i18n.getMessage('content_console_008'));
  } else if (host.indexOf('agrirxiv.org') > -1) {
    setTimeout(doOSFArxiv, 2500);
  } else if (!oah_processedSinglePageApplication && preprintServers.includes(document.location.hostname)) {
    oah_processedSinglePageApplication = true;
    setTimeout(findDoi, 2500);
  } else if (host.indexOf('tandfonline.com') > -1 && path.indexOf('/doi/full/')){
    doTandFOnline(oab, doistring, host);
  }
  else if (message != undefined && message == 'y') {
    doConsoleLog(chrome.i18n.getMessage('content_console_009'));
    requestDocument(oab, doistring);
  } else {
    requestDocument(oab, doistring);
  }
}

//

function successfulAlternativeOAFound(pdf, type = 'Open Access', onOaTest = false, doistring) {
  const message = new Array();
  message.url = pdf;
  message.title = `${type} found at: `;
  message.version = `${type} (*)`;
  message.source = 'Page Analysis';
  message.doi = doistring;
  oafound(message);
  const currentUrl = window.location.href;
  if (onOaTest) {
    onOa(message);
  } else {
    // safari.extension.dispatchMessage('compareURL', { current: currentUrl, goto: message.url });
  }
}


// runRegexOnDoc - inspired by unpaywall.org

function runRegexOnDoc(regEx) {
  const m = regEx.exec(document.documentElement.innerHTML);
  if (m && m.length > 1) {
    return m[1];
  }
  return false;
}

function runRegexOnText(text, regEx) {
  const m = regEx.exec(text);
  if (m && m.length > 1) {
    return m[1];
  }
  return false;
}

// helper function, checks DOI is valid and then logs to browser console and
// asks Extension Handler to get going

function scrapedDoi(doi) {
  if (isDOI(doi)) {
    // const url = encodeURI(location.href);
    doUnpayWall(doi);
  }
}

function webscraperBadge(selector, onoa, oab, doistring) {
  const selected = document.querySelectorAll(selector);
  if (selected.length == 0) {
    requestDocument(oab, doistring);
    return;
  }
  const { href } = document.querySelectorAll(selector)[0];
  if (href != null && href != '') {
    const message = new Array();
    message.url = href;
    message.title = 'Open Access found at: ';
    message.version = 'Free Access (*)';
    message.doi = doistring;
    oafound(message);
    if (onoa) {
      onOa(chrome.i18n.getMessage('content_onoa_001'));
    }
  } else {
    requestDocument(oab, doistring);
  }
}


function handleConfirmRequest(msg) {
  if (window.confirm(msg)) {
    // ask extension to go to user FAQ
    const url = 'https://www.oahelper.org/user-faq/';
    // safari.extension.dispatchMessage('oaURLReturn', { oaurl: url });
  }
}


function handleEzProxy(ezproxy) {
  const currentUrl = window.location.href;
  if (window.location.href.indexOf(ezproxy) > -1) {
    var url = currentUrl.replace(ezproxy, '');
  } else {
    var url = ezproxy + currentUrl;
  }
  window.location.href = url;
}


function evaluateTab() {
  const div = document.getElementById('oahelper_doicheckmark');
  let badge = '';
  if (div != undefined) {
    badge = div.dataset.badge;
  }
  if (badge == '!' || badge == '✔') {
    // safari.extension.dispatchMessage('badgeUpdate', { badge });
  }
}

// Core Recommender Related Functions

function coreRecommenderStart(doistring, infoString, closeLabel) {
  handlePreprintSites();

  if (isDOI(doistring)) {
    var doi = doistring;
  } else {
    return;
  }

  const currentUrl = document.URL;
  const docTitle = findTitle();
  const abstract = findAbstract();

  if (doi == '' && docTitle == '0' && abstract == '0') {
    return;
  }

  const src = chrome.runtime.getURL('images/recom.svg'); // padlock
  const message = chrome.i18n.getMessage('content_corerecom_001');

  const div = document.createElement('div');
  div.innerHTML = `<div class="oahelper_corerecom" title="${message}"><img id="oahelper_doicheckmark1" src="${src}" align="left"  title="${message}" data-doi="${doi}" data-badge=""/><span id="oahelper_oahelpmsg1">CORE Recommender</span></div>`; // data-oaurl is a gift to ourselves
  div.id = 'oahelper_corerecom_outer';
  div.className = 'oahelper_corerecom_outer oahelper_corecolor';
  if (configuration.nobadge) {
    div.className = 'oah_hidden';
  }
  if (document.body.parentNode.parentNode != '#document') {
    document.body.appendChild(div);
  }
  const element = document.getElementById('oahelper_corerecom_outer');
  // element.addEventListener("click", doCORERecom, false);
  addRecommenderClickHandler(element, infoString, closeLabel);
  doConsoleLog(chrome.i18n.getMessage('content_console_010'));
}

function addRecommenderClickHandler(element, infoString, closeLabel) {
  element.addEventListener('click', (e) => {
    doCORERecom(infoString, closeLabel);
  }, false);
}

function findAbstract() {
  const locations = ['DC.description', 'dc.Description', 'DCTERMS.abstract', 'eprints.abstract', 'description', 'Description'];
  let abstract = '0';

  for (i = 0; i < locations.length; i++) {
    if (abstract == '0') {
      abstract = getMetaForAbstract(locations[i]);
    }
  }
  const ogLocation = ['og:description'];
  for (j = 0; j < ogLocation.length; j++) {
    if (abstract == '0') {
      abstract = getMetaProperty(ogLocation[j]);
    }
  }
  if (abstract.length > 2000) {
    abstract = abstract.substring(0, 2000);
  }
  return abstract;
}

function findTitle() {
  const locations = ['citation_title'];
  let title = '0';

  for (i = 0; i < locations.length; i++) {
    if (title == '0') {
      title = getMetaForAbstract(locations[i]);
    }
  }
  if (title == 0) {
    title = document.title;
  }

  return title;
}


function doCORERecom(infoString, closeLabel) {
  const element = document.getElementById('oahelper_doicheckmark1');

  const { doi } = element.dataset;
  const currentUrl = document.URL;
  const docTitle = findTitle();
  const abstract = findAbstract();

  // remove button
  const element1 = document.getElementById('oahelper_corerecom_outer');
  element1.parentNode.removeChild(element1);

  const imgSrc = chrome.runtime.getURL('images/loader.gif');
  const logoSrc = chrome.runtime.getURL('images/core_logo.svg');

  // add sidebar // TO DO: the X close needs to be translatable
  const div = document.createElement('div');
  div.innerHTML = `<div id="oahelper_corerecommendations" ><div id="oahelper_corerecom_intro"><img src="${logoSrc}" id="oahelper_core_logo"> Recommender <div id="oahelper_core_x" title="close">X ${closeLabel}</div></div><div id="oahelper_correcom_intro2">${infoString}</div><div id="oahelper_spinner"><img src="${imgSrc}"></div></div>`; // data-oaurl is a gift to ourselves
  div.id = 'oahelper_corerecommender_outer';
  div.className = 'oahelper_corerecommender_outer';
  if (configuration.nobadge) {
    div.className = 'oah_hidden';
  }
  if (document.body.parentNode.parentNode != '#document') {
    document.body.appendChild(div);
  }

  const element2 = document.getElementById('oahelper_core_x');
  element2.addEventListener('click', dismissCoreRecommendations, false);

  setTimeout(() => {
    const element3 = document.getElementById('oahelper_corerecommender_outer');
    element3.classList.remove('oahelper_animate_out');
    element3.classList.add('oahelper_animate_in');
  }, 200);


  // safari.extension.dispatchMessage('requestRecommendation', {
  //  doi, currentUrl, docTitle, abstract,
  // });
  const mode = 'coreRecom';
  const infoString1 = chrome.i18n.getMessage('content_corerecom_002');
  chrome.runtime.sendMessage({
    mode,
    doi,
    currentUrl,
    docTitle,
    abstract,
  }, (response) => {
    showRecommendations(response.recommendation, infoString1);
  });
}

function dismissCoreRecommender() {
  doConsoleLog(chrome.i18n.getMessage('content_console_011'));

  var element = document.getElementById('oahelper_spinner');
  element.parentNode.removeChild(element);

  var element = document.getElementById('oahelper_correcom_intro2');
  element.parentNode.removeChild(element);

  const myRecomElement = document.getElementById('oahelper_corerecommendations');

  const div = document.createElement('div');
  div.className = 'oahelper_recommendation';
  div.innerHTML = `<p class="oahelper_recommendation_p">${chrome.i18n.getMessage('content_corerecom_003')}</p>`;
  myRecomElement.appendChild(div);

  setTimeout(() => {
    dismissCoreRecommendations();
  }, 5500);
}

function showRecommendations(data, infoString) {
  const element = document.getElementById('oahelper_spinner');
  element.parentNode.removeChild(element);

  const intro = document.getElementById('oahelper_correcom_intro2');
  intro.innerHTML = infoString;

  const myRecomElement = document.getElementById('oahelper_corerecommendations');
  const obj = data;

  if (obj === null) {
    dismissCoreRecommendations();
    return;
  }

  for (i = 0; i < obj.length; i++) {
    var year = "";
    var authors = "";
    var link = "";
    var title = obj[i].title;
    var foundLink = false;
    if(obj[i].yearPublished != ""){
        year = "("+obj[i].yearPublished+") ";
    }
    //get three authors & et al
    if(obj[i].authors.length > 0){
        var maxAuthors = 3;
        if(obj[i].authors.length < 3) {
            maxAuthors = obj[i].authors.length;
        }
        for(j=0; j<maxAuthors; j++){
            authors += obj[i].authors[j].name+"; ";
        }
        if (obj[i].authors.length > 3 ){
            authors += " et al.";
        }
    }
    if(obj[i].links.length > 0){
        for(k=0; k<obj[i].links.length; k++){
            if(obj[i].links[k].type == "download" && !foundLink){
                link = obj[i].links[k].url;
                foundLink = true;
            }
            if(obj[i].links[k].type == "display" && !foundLink){
                link = obj[i].links[k].url;
                foundLink = true;
            }
        }
    }
    const div = document.createElement('div');
    div.className = 'oahelper_recommendation';
    div.innerHTML = `<p class="oahelper_recommendation_p"><a href="${link}" target="_blank" class="oahelper_recommendation_a">${title}</a><br>${year}${authors}</p>`;
    myRecomElement.appendChild(div);
  }
}

function dismissCoreRecommendations() {
  const element = document.getElementById('oahelper_corerecommender_outer');
  element.parentNode.removeChild(element);
}


/** ********
*
* Handle Specific Vendor Sites
*
********* */


function doIngentaConnect(oab, doistring, host) {
  doConsoleLog(chrome.i18n.getMessage('content_console_013', host));
  // Ingenta Connect
  if (document.querySelectorAll("span.access-icon img[alt='Open Access']").length > 0) {
    const onclick = document.querySelectorAll('a.fulltext.pdf')[0].getAttribute('onclick');
    if (onclick != null && onclick != '' && onclick.indexOf('javascript' > -1)) {
      const href = onclick.replace("javascript:popup('", '').replace("','downloadWindow','900','800')", '');
      if (href != null && href != '') {
        var url = `${window.location.protocol}//${host}${href}`;
        successfulAlternativeOAFound(url, 'Free Access', true, doistring);
      } else {
        doConsoleLog(chrome.i18n.getMessage('content_console_012'));
        requestDocument(oab, doistring);
      }
    } else {
      const { popup } = document.querySelectorAll('a.fulltext.pdf')[0].dataset;
      if (popup != null && popup != '' && popup.indexOf('download' > -1)) {
        if (popup != null && popup != '') {
          var url = `${window.location.protocol}//${host}${popup}`;
          successfulAlternativeOAFound(url, 'Free Access', true, doistring);
        } else {
          doConsoleLog(chrome.i18n.getMessage('content_console_012'));
          requestDocument(oab, doistring);
        }
      } else {
        doConsoleLog(chrome.i18n.getMessage('content_console_012'));
        requestDocument(oab, doistring);
      }
    }
  }
  else{
    doConsoleLog(chrome.i18n.getMessage('content_console_012'));
    requestDocument(oab, doistring);
  }
}

function doBmj(oab, doistring, host) {
  doConsoleLog(chrome.i18n.getMessage('content_console_013', host));
  const bmjFreeAccessClass = 'highwire-access-icon highwire-access-icon-user-access user-access bmjj-free bmjj-free-access bmjj-access-tag';
  const pdf = getMeta('citation_pdf_url');
  if (document.querySelectorAll('svg.icon-open-access').length > 0) {
    if (pdf != '' && pdf.indexOf('http' == 0)) {
      successfulAlternativeOAFound(pdf, 'Open Access', true, doistring);
    } else {
      doConsoleLog(chrome.i18n.getMessage('content_console_012'));
      requestDocument(oab, doistring);
    }
  } else if (document.getElementsByClassName(bmjFreeAccessClass).length > 0) {
    const freeAccess = document.getElementsByClassName(bmjFreeAccessClass);
    const bmjFree = false;
    for (i = 0; i < freeAccess.length; i++) {
      if (freeAccess[i].textContent == 'Free' && !bmjFree) {
        successfulAlternativeOAFound(pdf, 'Free Access', true, doistring);
      }
    }
    if (!bmjFree) {
      doConsoleLog(chrome.i18n.getMessage('content_console_012'));
      requestDocument(oab, doistring);
    }
  } else {
    doConsoleLog(chrome.i18n.getMessage('content_console_012'));
    requestDocument(oab, doistring);
  }
}

function doBaseSearch(oab, doistring, host) {
  doConsoleLog(chrome.i18n.getMessage('content_console_013', host));
  if (document.querySelectorAll("img.pull-right[alt='Open Access']").length > 0) {
    webscraperBadge('a.link-gruen.bold', false, oab, doistring);
  } else {
    doConsoleLog(chrome.i18n.getMessage('content_console_012'));
    requestDocument(oab, doistring);
  }
}

function doIEEExplore(oab, doistring, host) {
  doConsoleLog(chrome.i18n.getMessage('content_console_013', host));
  if (document.querySelectorAll('i.icon-access-open-access').length > 0) {
    webscraperBadge('a.doc-actions-link.stats-document-lh-action-downloadPdf_2', false, oab, doistring);
  } else {
    doConsoleLog(chrome.i18n.getMessage('content_console_012'));
    requestDocument(oab, doistring);
  }
}

function doSagePub(oab, doistring, host) {
  doConsoleLog(chrome.i18n.getMessage('content_console_013', host));
  if (document.querySelectorAll('img.accessIcon.freeAccess').length > 0) {
    webscraperBadge('a[data-item-name="download-PDF"]', true, oab, doistring);
  } else {
    doConsoleLog(`Open Access Helper (Chrome Extension): We are checking: ${host} for hybrid journal access`);
    if (document.querySelectorAll('img.accessIcon.openAccess').length > 0) {
      webscraperBadge('div.pdf-access>a', true, oab, doistring);
    } else {
      doConsoleLog(chrome.i18n.getMessage('content_console_012'));
      requestDocument(oab, doistring);
    }
  }
}

function doOup(oab, doistring, host) {
  doConsoleLog(chrome.i18n.getMessage('content_console_013', host));
  if (document.querySelectorAll('i.icon-availability_free').length > 0) {
    webscraperBadge('a.article-pdfLink', true, oab, doistring);
  } else {
    doConsoleLog(chrome.i18n.getMessage('content_console_012'));
    requestDocument(oab, doistring);
  }
}

function doCambridge(oab, doistring, host) {
  doConsoleLog(chrome.i18n.getMessage('content_console_013', host));
  if (document.querySelectorAll('span.entitled').length > 0) {
    const pdf = getMeta('citation_pdf_url');
    if (pdf != '' && pdf.indexOf('http' == 0)) {
      successfulAlternativeOAFound(pdf, 'Free / Subscription Access', true, doistring);
    }
  } else {
    doConsoleLog(chrome.i18n.getMessage('content_console_012'));
    requestDocument(oab, doistring);
  }
}

function doWiley(oab, doistring, host) {
  doConsoleLog(chrome.i18n.getMessage('content_console_013', host));
  const toCheck = document.querySelectorAll('div.article-citation > div > div.doi-access-container.clearfix > div > div');
  const toCheck2 = document.getElementById('pdf-iframe');
  if (toCheck.length > 0 && toCheck[0].innerHTML.indexOf('Free Access')) {
    if (toCheck2 === null) {
      doConsoleLog('Open Access Helper (Chrome Extension): We found FREE Access');
      const pdf = getMeta('citation_pdf_url');
      successfulAlternativeOAFound(pdf, 'Free Access', true, doistring);
    }
  } else {
    doConsoleLog(chrome.i18n.getMessage('content_console_012'));
    if (toCheck2 === null) {
      requestDocument(oab, doistring);
    }
  }
}

function doSpringerLink(oab, doistring, host) {
  doConsoleLog(chrome.i18n.getMessage('content_console_013', host));
  const toCheck = document.querySelectorAll('div.download-article');
  if (toCheck.length > 0 && toCheck[0].innerHTML.indexOf('Download') > -1) {
    doConsoleLog('Open Access Helper (Chrome Extension): We found FREE / Subscription Access');
    const pdf = getMeta('citation_pdf_url');
    successfulAlternativeOAFound(pdf, 'Free / Subscription Access', true, doistring);
  } else {
    doConsoleLog(chrome.i18n.getMessage('content_console_012'));
    requestDocument(oab, doistring);
  }
}

function doTandFOnline(oab, doistring, host){
  doConsoleLog(chrome.i18n.getMessage('content_console_013', host));
  const toCheck = document.querySelectorAll('div.accessIconLocation');
  if (toCheck.length > 0 && toCheck[0].alt == 'Open access' && getMeta('citation_fulltext_world_readable').length > 0){
    doConsoleLog('Open Access Helper (Chrome Extension): We found Open Access');
    successfulAlternativeOAFound(window.location.href, 'Open Access', true, doistring);
  }
  else{
    doConsoleLog(chrome.i18n.getMessage('content_console_012'));
    requestDocument(oab, doistring);
  }
}

function doPsycNet() {
  if (((window.location.pathname.indexOf('/search/display') > -1) || (window.location.pathname.indexOf('/record/') > -1) || (window.location.pathname.indexOf('/fulltext/') > -1)) && oah_processedSinglePageApplication == false) {
    removeMyself();
    setTimeout(() => {
      oah_processedSinglePageApplication = true;
      findDoi();
    }, 4500);
  }
}


function doOaHelperLiveRegion(message) {
  setTimeout(() => {
    const div = document.getElementById('oahelper_LiveRegion');
    if (div != null) {
      div.innerHTML = message;
    }
  }, 4000);
}

function addCitationCount(count, doi) {
  doConsoleLog(chrome.i18n.getMessage('content_console_014', count));

  const url = `https://www.oahelper.org/opencitations/?doi=${doi}`;
  const message = `${chrome.i18n.getMessage('content_times_cited')} ${count}`;
  const src = chrome.runtime.getURL('images/ocicon.svg');
  const div = document.createElement('div');

  div.innerHTML = `<div class="oahelper_opencitations" onclick="window.open('${url}')" title="OpenCitations ${message}"><img id="oahelper_opencitations_logo" src="${src}" align="left" title="${message}" data-citcount="${count}" data-oaurl="${url}" data-badge="oc"/><span id="oahelper_opencitations_msg">${message}</span></div><span id="oahelper_opencitations_LiveRegion" role="alert" aria-live="assertive" aria-atomic="true"></span>`; // data-oaurl is a gift to ourselves
  div.id = 'oahelper_opencitations_outer';
  div.className = 'oahelper_opencitations_outer';
  if (configuration.nobadge) {
    div.className = 'oah_hidden';
  }

  if (document.body.parentNode.parentNode != '#document') {
    document.body.appendChild(div);
  }
}

function doUnpayWall(cleanedDOI) {
  chrome.runtime.sendMessage({ mode: 'getoptions' }, (response) => {
    if (response.options != undefined && !response.options != null) {
      configuration = response.options;
    }
    doCitationCount(cleanedDOI);
  });

  if (document.getElementById('oahelper_doifound_outer') != undefined) {
	  return;
  }


  const mode = 'unpaywall';
  chrome.runtime.sendMessage({ mode, cleanedDOI }, (response) => {
    if (response.data.is_oa && response.data.best_oa_location != null) {
      response.data.best_oa_location.doi = cleanedDOI;
      oafound(response.data.best_oa_location);
      followUrl(response.data.best_oa_location.url);
    } else {
      doCoreOpenAccess(cleanedDOI, response.data.year);
    }
  });
}

function doCoreOpenAccess(cleanedDOI, year) {
  // config disabled Core OpenAccess, but OpenAccessButton and CoreRecommender requested
  if (configuration != null && !configuration.core && configuration.oab && configuration.core1) {
    requestDocument(createOABValue(year), cleanedDOI);
    const infoString = chrome.i18n.getMessage('content_corerecom_004');
    coreRecommenderStart(cleanedDOI, infoString, chrome.i18n.getMessage('content_close_label'));
    return;
  }
  // config disabled Core OpenAccess and OpenAccessButton but CoreRecommender requested
  if (configuration != null && !configuration.core && !configuration.oab && configuration.core1) {
    const infoString = chrome.i18n.getMessage('content_corerecom_004');
    coreRecommenderStart(cleanedDOI, infoString, chrome.i18n.getMessage('content_close_label'));
    return;
  }
  // config disabled Core OpenAccess and CoreRecommender, but OpenAccessButton requested
  if (configuration != null && !configuration.core && configuration.oab && !configuration.core1) {
    requestDocument(createOABValue(year), cleanedDOI);
    return;
  }
  // config disabled all additional services
  if (configuration != null && !configuration.core && !configuration.oab && !configuration.core1) {
    return;
  }
  const mode = 'coreoa';
  chrome.runtime.sendMessage({ mode, cleanedDOI }, (response) => {
    if (response.data.fullTextLink != null) {
      const best_oa_location = {
        source: 'Core.ac.uk',
        url: response.data.fullTextLink,
        title: 'Open Access Version found from core.ac.uk!',
        version: 'core',
        doi: cleanedDOI,
      };
      oafound(best_oa_location);
    } else {
      // requestDocument(createOABValue(year), cleanedDOI);
      // const infoString = chrome.i18n.getMessage('content_corerecom_004');
      // coreRecommenderStart(cleanedDOI, infoString, chrome.i18n.getMessage('content_close_label'));
      if(configuration.oab){
        alternativeOA('y', createOABValue(year), cleanedDOI);
      }
      else{
        alternativeOA('y', createOABValue(year), cleanedDOI);
      }
      
    }
  });
}

function createOABValue(year) {
  // oab: y = yes, e = error getting data, o = older than 5 years ago
  const currentYear = new Date().getFullYear();
  const fiveYearsAgo = currentYear - 6;
  if (year === 0 || year > fiveYearsAgo) {
    return 'y';
  }
  if (year === 1) {
    return 'e';
  }

  return 'n';
}

function doCitationCount(cleanedDOI) {
  if (configuration != null && !configuration.opencitation) {
	  doConsoleLog('opencitation disabled');
	  return;
  }
  const mode = 'citationcount';
  chrome.runtime.sendMessage({ mode, cleanedDOI }, (response) => {
    if (response.citationCount != undefined && response.citationCount > 0) {
      addCitationCount(response.citationCount, cleanedDOI);
    }
  });
}

function followUrl(targetUrl) {
  const mode 		= 'followUrl';
  const currentUrl 	= window.location.href;
  chrome.runtime.sendMessage({ mode, currentUrl, targetUrl }, (response) => {
    if (response.ona != undefined && response.ona == true) {
      // the current location is Open Access
      onOa(chrome.i18n.getMessage('content_onoa_001'));
    }
  });
}


function doConsoleLog(message) {
  if (configuration.consolelog != undefined && configuration.consolelog) {
    // console.log(message);
  }
}

function handlePreprintSites() {
  if (document.location.href.indexOf('www.biorxiv.org') > -1 || document.location.href.indexOf('www.medrxiv.org') > -1) {
    doBioMedArxiv();
  } else if (
    document.location.href.indexOf('osf.io/preprints') > -1 || 
    document.location.href.indexOf('engrxiv.org/') > -1 ||
    document.location.href.indexOf('biohackrxiv.org/') > -1 ||
    document.location.href.indexOf('ecsarxiv.org') > -1 ||
    document.location.href.indexOf('frenxiv.org/') > -1 ||
    document.location.href.indexOf('mediarxiv.org/') > -1
  ) {
    doOSFArxiv();
  } else if (document.location.href.indexOf('arxiv.org') > -1) {
    doArxivOrg();
  }
}

function doBioMedArxiv() {
  const possibleDocs = document.getElementsByClassName('article-dl-pdf-link link-icon');
  if (possibleDocs.length > 0) {
    for (const link of possibleDocs) {
      const href = link.getAttribute('href');
      if (href.indexOf('pdf') > -1) {
        // I am on Open Access
        const url = `${window.location.protocol}//${window.location.hostname}${href}`;
        successfulAlternativeOAFound(url, 'Preprint Server', true, '-');
      }
    }
  }
}

function doArxivOrg() {
  const possibleDocs = document.getElementsByClassName('abs-button download-pdf');
  if (possibleDocs.length > 0) {
    for (const link of possibleDocs) {
      const href = link.getAttribute('href');
      if (href.indexOf('pdf') > -1) {
        // I am on Open Access
        const url = `${window.location.protocol}//${window.location.hostname}${href}`;
        successfulAlternativeOAFound(url, 'Preprint Server', true, '-');
      }
    }
  }
}

function doOSFArxiv() {
  const classArray = ['btn btn-primary p-v-xs', 'btn btn-primary p-v-xsf', 'pdf-download-link'];
  classArray.forEach(className => {
    const possibleDocs = document.getElementsByClassName(className);
    if (possibleDocs.length > 0) {
      for (const link of possibleDocs) {
        const href = link.getAttribute('href');
        if (href.indexOf('download') > -1) {
          // I am on Open Access
          const url = `${href}`;
          successfulAlternativeOAFound(url, 'Preprint Server', true, '');
        }
      }
    }
  });
}

function shouldProxy(currenturl) {
  let returnValue = false;
  if (configuration.domainurl == undefined || configuration.domainurl == "undefined" || configuration.domainurl == '') {
    returnValue = true;
  }
  else{
    configuration.supportedDomains.forEach(function(a){
      // console.log(a);
      if (typeof(a) == 'string' && currenturl.indexOf(a)>-1) {
        returnValue = true;
      }        
    });
  }
  
  return returnValue;
}
